import { NgModule } from '@angular/core';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { RouterModule as NgRouterModule } from '@angular/router';
import { UpgradeModule as NgUpgradeModule } from '@angular/upgrade/static';

import { CoreModule, RouterModule, HOOK_COMPONENT } from '@c8y/ngx-components';	//HOOK_COMPONENT追加

import { UpgradeModule, HybridAppModule, UPGRADE_ROUTES } from '@c8y/ngx-components/upgrade';
import { AssetsNavigatorModule } from '@c8y/ngx-components/assets-navigator';
import { ReportsModule } from '@c8y/ngx-components/reports';
import { ContextDashboardModule } from '@c8y/ngx-components/context-dashboard';

//追加
import { WidgetDemo } from './view-widget.component';
import { WidgetConfigDemo } from './view-widget-config.component';


@NgModule({
  imports: [
    BrowserAnimationsModule,
    RouterModule.forRoot(),
    NgRouterModule.forRoot([...UPGRADE_ROUTES], { enableTracing: false, useHash: true }),
    CoreModule.forRoot(),
    AssetsNavigatorModule,
    ReportsModule,
    NgUpgradeModule,
    ContextDashboardModule,
    // Upgrade module must be the last
    UpgradeModule
  ],
  //追加
  declarations: [WidgetDemo, WidgetConfigDemo],	
  entryComponents: [WidgetDemo, WidgetConfigDemo],  //エントリーコンポーネントとして定義
  providers: [{
  	provide: HOOK_COMPONENT,		//HOOK_COMPONENTと共にマルチプロバイダーフックを追加
  	multi: true,
  	useValue: {
  		id: 'kawato.text.widget',　　//一意なIDを設定
  		label: 'View Widget',
  		description: 'Can display a text',
  		component: WidgetDemo,				//コンポーネントをウィジェットに関連付け
      configComponent: WidgetConfigDemo,
      //デバイス選択画面の非表示オプション（デバイスの情報が不要なため、任意で追加）
      data: {ng1: { options: {
        noDeviceTarget: true
      }}}
    }
  }],
  
})
export class AppModule extends HybridAppModule {
  constructor(protected upgrade: NgUpgradeModule) {
    super();
  }
}
